//
//  Copyright (C) by S.Tomabechi 1993,1995
//  All rights reserved
//
//  create table of Bernoulli numbers
//
//  t@C̎dl
//  Bernoullǐ (2byte)
//  Bernoulli̕q,Bernoulli̕ ̏
//                    (iobinary.cpp ̊֐ēǂݏ)
//
//  Bernoulli͖̕Ă̐Βl
//  B0,B2,....B2n
//
#include "Mint.hpp"
#include <iomanip.h>
#include <fstream.h>
#include "Error.hpp"

#ifdef __BORLANDC__
#  include <constrea.h>
#else
  int wherex(void) ;
  int wherey(void) ;
  void clrscr(void) ;
  void gotoxy(int x,int y) ;
#endif

int main(void)
{
  int nx=1000*2 ;              // sȂǂœȂ͂炷

//cout << endl << "input " ;
//cin >> nx ;

#ifdef __BORLANDC__
constream con ;
con.clrscr() ;
con.window(1,1,80,24) ;
con.rdbuf()->gotoxy(3,2) ;

con <<  "Bernoulli number  " << nx/2 << " vZ" ;
#else
clrscr() ;
gotoxy(3,2) ;
cout <<  "Bernoulli number  " << nx/2 << " vZ" << flush  ;
#endif

  int j ;
  Mint t1,t2,tt ;
  ofstream out(".\\bernoull.tbl",ios::binary) ;

  j=(nx+2)/2 ;
  out.write((char*)&j,sizeof(int)) ;
  t1=1 ;
  write(out,t1) ;
  write(out,t1) ;

  Mint b1,b2 ;
  Mint w ;

  int nh=((nx+3)/4)*2 ;
  int k ;
  Mint* t  ;
  t=new Mint[nh/2+1] ;
  if( !t ) Error( allocate error) ;
  int n=1 ;
  Mint q(1) ;
  int kx=0 ;

  t[0]=1 ;

  j=0 ;
  do {

    t1=t[0] ;

    for( k=1 ; k<=kx ;k++ ) {
      t2=t[k] ;
      t[k]=(2*k-1)*t1+(2*k+1)*t[k] ;
      t1=t2 ;
    }
    t[k]=(2*k-1)*t1 ;
    tt=t[0] ;

    n++ ;
    for( k=0 ; k<=kx ; k++ ) {
      t[k]=2*k*t[k]+2*(k+1)*t[k+1] ;
    }
    t[k] *= (2*k)  ;
    q *= 4 ;
    b1=n*tt ;

    b2=q*(q-1) ;

    w=gcd(b1,b2) ;
//cout << endl << ++j ;
    b1 /= w ;
    b2 /= w ;
    write(out,b1) ;
    write(out,b2) ;
#ifdef __BORLANDC__
con.rdbuf()->gotoxy(5,5) ;
con << ++j << '/' << nh ;
#else
gotoxy(5,5) ;
cout << ++j << '/' << nh << flush ;
#endif
//cout << endl << b1 ;
//cout << "  " << endl << b2 << flush ;
    n++ ;
    kx++ ;
  } while( n<=nh )  ;


  do {
    kx-- ;
    t1=t[0] ;
    for( k=1 ; k<=kx ; k++ ) {
      t2=t[k] ;
      t[k]=(2*k-1)*t1+(2*k+1)*t[k] ;
      t1=t2 ;
    }

    tt=t[0] ;

    n++ ;

    for( k=0 ; k<=kx ; k++ ) {
      t[k]=2*k*t[k]+2*(k+1)*t[k+1] ;
    }
    q *= 4 ;
    b1=n*tt ;
    b2=q*(q-1) ;
    w=gcd(b1,b2) ;
//cout << endl << j++ ;
    b1 /= w ;
    b2 /= w ;
    write(out,b1) ;
    write(out,b2) ;
#ifdef __BORLANDC__
con.rdbuf()->gotoxy(5,5) ;
con << ++j << '/' << nh ;
#else
gotoxy(5,5) ;
cout << ++j << '/' << nh << flush ;
#endif


//cout << endl << b1 ;
//cout << "  " << endl << b2 << flush ;


    n++ ;
  } while( n<=nx ) ;


  delete [] t ;
  out.close() ;

  cout << endl << endl << "  normal end " ;
  return 0 ; 
}
