//
//  Copyright (C) 1993,1994,1995  by S.Tomabechi
//     All rights reserved
//
//  Cpmpare real numbers
//
// return value   1 : *this>a
//                0 : *this==a
//               -1 : *this<a
//
#ifdef __BORLANDC__
#  pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Fint
#endif

#define _ONLY_MINTDECL_
#include "Fint.hpp"

int Fint::compare(const Mint& n) const
{
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
n.check(__FILE__,__LINE__) ;
#endif
  signed char sign ;

  __asm {
    mov   esi,this
    mov   edi,n

#ifdef __BORLANDC__                              // compare signature
    mov  al,byte ptr [esi.nDim+3]
    mov  sign,al
    cmp  al,byte ptr [edi.nDim+3]
#else
    mov   al,byte ptr [esi+SIGN]
    mov   sign,al
    cmp   al,byte ptr [edi+SIGN]
#endif
    jne   Great                                  // not same signature

#ifdef __BORLANDC__
    mov   ecx,[esi.nDigit]             // # of significant digits
    mov   ebx,[edi.nDigit]
#else
    mov   ecx,dword ptr [esi+NDIGIT]
    mov   ebx,dword ptr [edi+NDIGIT]
#endif

    or   ecx,ecx            // *this=0 ?
    jnz  IsZero2
    or   ebx,ebx            // n is also zero ?
    jz   Equal              // yes this=0 and n=0
    jmp  Less               // n>0(=*this)
  }
IsZero2:                    // this!=0 here
  __asm {
     or ebx,ebx             // n is zero ?
     jz Great
                            // both number are neither 0
#ifdef __BORLANDC__
    sub ecx,[esi.fDigit]
    sub ebx,[edi.fDigit]
#else
    sub ecx,[esi+FDIGIT]
    sub ebx,[edi+FDIGIT]
#endif
    cmp   ecx,ebx
    jg    Great
    jl    Less
  }
                        // Ȍ̈ʂ͓
  __asm {
#ifdef __BORLANDC__
    mov   ecx,[esi.nDigit]
    mov   ebx,[edi.nDigit]
    mov   esi,[esi]
    mov   edi,[edi]
#else
    mov   ecx,[esi+NDIGIT]
    mov   ebx,[edi+NDIGIT]
    mov   esi,[esi]
    mov   edi,[edi]
#endif
    cmp   ecx,ebx          // comapre #significant digits
    jge   Compare
    xchg  ecx,ebx
    xchg  esi,edi
    neg   sign
  }
Compare:                   // Ƃ digit ɖߍ܂Čr
  __asm {
    mov   eax,[ecx*NBYTE+esi-NBYTE]
    cmp   eax,[ebx*NBYTE+edi-NBYTE]
    ja    Great
    jb    Less
    dec   ecx
    dec   ebx
    jnz   Compare

    or    ecx,ecx          // Are digits remained ?
    jz    Equal

  }
Zero1:                     // remained digits are 0 ?
  __asm {
    cmp   dword ptr [ecx*NBYTE+esi-NBYTE],0
    jne   Great
    dec   ecx
    jnz   Zero1
  }
Equal:
  __asm {
    mov   sign,0
    jmp   RET1
  }
Less:
  __asm neg sign
Great:
RET1:
  return (int)sign ;
}

