//
//  Copyright (C) by S.Tomabechi 1993,1994,1995
//  All rights reserved.
//
//  compare two integers
//
//  return value   1 : *this>a
//                 0 : *this==a
//                -1 : *this<a
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

int Mint::compare(const Mint& a) const
{
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
a.check(__FILE__,__LINE__) ;
#endif

  signed char sign ;

  __asm {

    mov   esi,this
    mov   edi,a
#ifdef __BORLANDC__
    mov   al,[esi.nDim+3]
    mov   sign,al
    cmp   al,[edi.nDim+3]    // compare signs
#else
    mov   al,[esi+SIGN]
    mov   sign,al
    cmp   al,[edi+SIGN]
#endif
    jne   Great
  }
                                        // same signature
  __asm {
#ifdef __BORLANDC__
    mov   ecx,[edi.nDigit]    // number of digits
    cmp   [esi.nDigit],ecx    // compare number of digits
#else
    mov   ecx,[edi+NDIGIT]
    cmp   [esi+NDIGIT],ecx
#endif
    ja    Great
    jb    Less
  }
  __asm {                               // same number of digits
                                        // compare their absolute values
//    jecxz Equal                         // both 0
    dec ecx
    js  Equal
#ifdef __BORLANDC__
    mov   esi,[esi]
    mov   edi,[edi]
#else
    mov   esi,[esi]
    mov   edi,[edi]
#endif
  }
Compare:                      // compare digit as unsigned long integer
  __asm {
    mov   eax,[ecx*NBYTE+esi]
    cmp   eax,[ecx*NBYTE+edi]
    jb    Less                      // less
    ja    Great                     // greater
    dec   ecx
    jns   Compare
  }
Equal:                             // same
  __asm {
    mov   sign,0
    jmp   Great
  }
Less:
  __asm neg sign
Great:
  return (int)sign ;

}

