//
//  Copyright (C) by S.Tomabechi 1997
//  All rights reserved.
//
//  compare multiple precision integer and long integer
//
//  return value  -1 : *this<n
//                 0 : *this=n
//                 1 : *this>n
//
//  1997/03/08
//  ]̂ł͐Βlꍇ܂łȂ̂ŁA
//  long Ƃ̔r֐쐬D
//
//  1998/03/18
//   *this=0 ̏ꍇ 召֌Wt]Ă
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

int Mint::compare(const long n) const
{
#ifdef _MEMMAN_DEBUG
this->check(__FILE__,__LINE__) ;
#endif
  int  sign(1) ;
  __asm {
    mov   esi,this

    mov   ebx,n
    or    ebx,ebx              // n  is positive ?
    jge   POSITIVE

#ifdef __BORLANDC__
    cmp   dword ptr [esi.nDim],0  // *this is positive ?
#else
    cmp   dword ptr [esi+NDIM],0
#endif
    jge   Great              // *this>0 n<0

    neg   sign
    neg   ebx
    jmp   COMP
  }
POSITIVE:
  __asm {
#ifdef __BORLANDC__
    cmp dword ptr [esi.nDim],0  // *this is positive ?
#else
    cmp dword ptr [esi+NDIM],0
#endif
    jl  Less                 // *this<0 n>0
  }
COMP:
  __asm {
#ifdef __BORLANDC__
    cmp   dword ptr [esi.nDigit],1  // #digit > 1 ?
#else
    cmp   dword ptr [esi+NDIGIT],1
#endif
    jg    Great                    // #digit >1
    je    DIGIT1                   // #digit=1

                                   //  *this=0
    or    ebx,ebx                  // n=0 also ?
    jnz   Less                     //  not n=0
    jmp   Equal
  }

DIGIT1:
  __asm {                          // #digit=1

#ifdef __BORLANDC__
        mov   esi,[esi]
#else
        mov   esi,[esi]
#endif
        cmp   [esi],ebx            // compare ditit[0] to n
        ja    Great                  // digit[0]>n
        jb    Less                   // digit[0]<n
  }

Equal:
  __asm {
        mov   sign,0
        jmp   RET1
  }
Less:
  __asm neg sign
Great:
RET1:
  return sign ;
}
