//
//  Copyright (C) by S.Tomabechi 1997
//  All rights reserved.
//
//  Fourier transformation and inverse Fourier transfomation
//
//  Fourier ϊ  Fourier tϊ
//
//  AZug͂ȂAgȂ 4096 
//  ꍇłʏ̏Z. ł͖ӖȂ̂ŁAAZu
//  gD
//
//  1997/06/10
//
#ifdef __BORLANDC__
#pragma inline
#endif

#include "FFT.hpp"
#include "Error.hpp"
#include <iostream.h>
////////////////////////////////////
//
// Fourier transformation
//
void FFT::fft(unsigned long* data,unsigned long prime,unsigned long* roots)
{
  unsigned long nmax,m,k,istep,ii,jj,NN ;
  unsigned long w ;
  __asm {
    mov  ecx,prime           // fix ecx=primes
    mov  ebx,data
#ifdef __BORLANDC__
    mov  edi,this
    mov  eax,[edi.N]
    mov  NN,eax
    mov  nmax,eax                    // nmax=N
    mov  edx,[edi.logN]
    mov  k,edx                       // k=logN
#else
    mov  edi,this
    mov  eax,[edi+_N]
    mov  NN,eax
    mov  nmax,eax                    // nmax=N
    mov  edx,[edi+_LOGN]
    mov  k,edx                       // k=logN
#endif
  }
MAINLOOP:
  __asm {
    dec k
    js  RET1                // k>=0 ?
    mov eax,nmax
    mov istep,eax           // istep=nmax
    shr eax,1
    mov nmax,eax            // nmax>>=1

    mov eax,NN

    xor edx,edx
    mov ii,eax
    div istep
    sub ii,eax              // ii=N-N/istep
    mov jj,eax

  }
    __asm {
      mov  esi,1
    }
LOOP0:
    __asm {
      mov  edi,esi
      add  edi,nmax                        // j=i+nmax
      mov  eax,[esi*4+ebx]      // data[i]
      sub  eax,[edi*4+ebx]      // temp=data[i]-data[j]
      jnc  ADD0
      add  eax,ecx                         // temp += prime

    }
ADD0:
    __asm {
      mov edx,[edi*4+ebx]      // data[j]
      add [esi*4+ebx],edx      // data[j]+data[i]
      jc  NEG1                 // not necessary when  prime<2^31
      cmp [esi*4+ebx],ecx      // data[i]>prime ?
      jb MOVE0
   }
NEG1:
  __asm {
      sub [esi*4+ebx],ecx      // data[i] -= prime
  }
MOVE0:
    __asm {
      mov [edi*4+ebx],eax     // data[j]=temp
      add esi,istep
      cmp esi,NN
      jbe LOOP0
    }
    __asm {
      mov m,2
    }
LOOP10:
      __asm {
        mov eax,nmax
        cmp m,eax
        ja  NEXT_k
        mov esi,ii
        mov edx,roots
        mov eax,[esi*4+edx]   //roots[ii]
        mov w,eax                        // ^ij
        sub esi,jj
        mov ii,esi

      }
      __asm {
        mov esi,m
      }
LOOP1:
        __asm {
          mov edi,esi
          add edi,nmax                    // j=i+nmax
          mov eax,[esi*4+ebx]  // data[i]
          mov edx,[edi*4+ebx]  // data[j]
          sub eax,edx                     // temp=data[i]-data[j]
          jnc ADD1
          add eax,ecx                     // temp += prime
        }
ADD1:
        __asm {
          add [esi*4+ebx],edx   // data[i]+=data[j]
          jc  NEG2              // not necessary when  prime<2^31
          cmp [esi*4+ebx],ecx   // data[i]>prime ?
          jb  MOD1
        }
NEG2:
        __asm {
          sub [esi*4+ebx],ecx   // data[i] -= prime
        }
MOD1:
        __asm {
          mul  w                           // w*temp(=eax)
          div ecx                          // mod prime
          mov [edi*4+ebx],edx   // data[j]=residue
          add esi,istep
          cmp esi,NN
          jbe LOOP1
        }
      __asm {
        inc m
        jmp LOOP10

      }
NEXT_k:
    __asm jmp MAINLOOP
RET1: ;
}

//////////////////////////////////////////
//
//  inverse Fourier transformation
//
//  roots={ roots of unity mod prime }
//
void FFT::ifft(unsigned long* data,unsigned long prime,unsigned long* roots)
{
  unsigned long nmax,m,k,istep,ii,jj,NN ;
  unsigned long w ;                         // root of unity
  __asm {
    mov ecx,prime
    mov ebx,data
    mov nmax,1
    mov edi,this

#ifdef __BORLANDC__
    mov eax,[edi.N]
    mov NN,eax
    mov eax,[edi.logN]
#else
    mov eax,[edi+_N]
    mov NN,eax
    mov eax,[edi+_LOGN]
#endif
    mov k,eax
  }
MAINLOOP:
  __asm {
    dec k
    js  RET1
    mov eax,nmax
    shl eax,1
    mov istep,eax
    mov eax,NN
    xor edx,edx
    div istep
    mov jj,eax
    mov ii,eax

    mov esi,1
  }
LOOP0:
    __asm {
      mov edi,esi
      add edi,nmax
      mov eax,[edi*4+ebx]  // temp=data[j]
      mov edx,[esi*4+ebx]  // data[i]
      sub edx,eax                     // data[i]-temp
      jnc MOVE0
      add edx,ecx                     //  += prime
    }
MOVE0:
    __asm {
      mov [edi*4+ebx],edx  // data[j]=data[i]-temp
      mov edx,[esi*4+ebx]  // data[i]
      add edx,eax                     // data[i] += temp
      jc  NEG1
      cmp edx,ecx
      jb  SET_d
    }
NEG1:
    __asm {
      sub edx,ecx
    }
SET_d:
    __asm {
      mov [esi*4+ebx],edx
      add esi,istep
      cmp esi,NN
      jbe LOOP0

    }
    __asm {
      mov m,2

    }
LOOP10:
    __asm {
      mov eax,nmax
      cmp m,eax
      ja  NEXT_k
      mov esi,ii
      mov edx,roots
      mov eax,[esi*4+edx]   //roots[ii]
      mov w,eax                        // ^ij
      add esi,jj
      mov ii,esi
    }
      __asm {
        mov esi,m
      }
LOOP1:
        __asm {
          mov edi,esi
          add edi,nmax                      // j=i+nmax
          mov eax,[edi*4+ebx]    // data[j]
          mul w                             // w*data[j]
          div ecx                           // mod prime
          mov eax,[esi*4+ebx]    // data[i]
          sub eax,edx                       // data[j]=data[i]-temp
          jnc MOVE1
          add eax,ecx                       // data[j] += prime
        }
MOVE1:
        __asm {
          mov [edi*4+ebx],eax    // data[j]
          add [esi*4+ebx],edx    // data[i]+= temp
          jc  NEG2
          cmp [esi*4+ebx],ecx
          jb  NEXT1
        }
NEG2:
        __asm {
          sub [esi*4+ebx],ecx
        }
NEXT1:
      __asm {
        add esi,istep
        cmp esi,NN
        jbe LOOP1
      }
      __asm {
        inc m
        jmp LOOP10

      }
NEXT_k:
    __asm {
      mov eax,istep
      mov nmax,eax
      jmp MAINLOOP
    }
RET1: ;
}

FFT::~FFT()                              // destructor
{
#ifdef FFT_DEBUG
if( ncalled!=0 ) cout << endl << "FFT  " << N << " " << ncalled << flush ;
#endif
  for( int j=0 ; j<3 ; j++ ) {
    delete [] roots[j] ;
    delete [] d[j] ;
    d[j]=NULL ;
  }
  maxN=0 ;
}

