//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  return inverse modulo p
//
//  It is not necessary that p is prime.
//
//  return value   x  s.t. a*x=1 mod p if a is coprime to p.
//                 0  if gcd(a,p)!=1
//
//  ax=1 mod p ƂȂ x ߂
//  ݂ȂƂ́A0Ԃ.
//  p ͑fłȂĂ悢
//
//  vZ̓r unsigned long  64 rbg̕␔ ƂĈKv
//

#ifdef __BORLANDC__
#pragma inline
#endif

unsigned long invmodp(const unsigned long a,const unsigned long p)
{

  unsigned long v1(0),v12(0) ;
//  unsigned long v3 ;          <-> edi
  unsigned long t3,p1,p12 ;

  __asm {
    mov  ebx,p
    or   ebx,ebx            // p is zero ?
    jz   SET_ZERO
  }
Check_a:
  __asm {

    mov  edi,ebx            // ebx=v3
    xor  ecx,ecx
    mov  ebx,1              // ecx is inverse

    mov  eax,a              // fixed eax=a
  }
MAIN_LOOP:
  __asm {
    or   edi,edi            // return if v3=0
    jnz  DIVIDE

    cmp  eax,1
    jne  SET_ZERO

    or   ecx,ecx
    jz   RET1                 //
    add  ebx,p                // make ebx positive
    jmp  RET1
  }
DIVIDE:
  __asm {

    xor  edx,edx
    div  edi                // a/v3
    mov  t3,edx            // save residue

    mov  esi,eax

    mov  eax,v1
    mul  esi
    mov  p1,eax
    mov  p12,edx

    mov  eax,v12
    mul  esi
    add  p12,eax

    sub  ebx,p1            // ecx -= q*v1
    sbb  ecx,p12
    xchg ebx,v1
    xchg ecx,v12

    mov  eax,t3
    xchg eax,edi
    jmp  MAIN_LOOP
  }
SET_ZERO:
   __asm xor ebx,ebx

RET1:
#ifdef __BORLANDC__
  __asm mov eax,ebx
  return _EAX ;
#else
  __asm mov a,ebx
  return a ;
#endif
}
