//
//  Copyright (C) by S.Tomabechi November 1993
//  All rights reserved.
//
//  integral part of square root
//
//  sqrt(n1*b+n0)   b=2^32
//
#ifdef __BORLANDC__
#pragma inline
#endif
unsigned long isqrt(const unsigned long n0,const unsigned long n1)
{

  __asm {

    mov esi,n0
    mov eax,n1
    mov edi,eax

    bsr ecx,eax
    jz  DIGIT1
    add ecx,32
    jmp SQRT
  }
DIGIT1:
  __asm {
    mov eax,n0
    bsr ecx,eax            // bit length of n
    jz  RET1
  }
SQRT:
  __asm {
    mov ebx,1
    inc ecx                // l=l+1  l: length of n 
    shr ecx,1              // l/=2
    inc ecx                // l++
    shl ebx,cl             // initial value for Newton method 
  }
SQ_LOOP:
  __asm {
    mov eax,esi
    mov edx,edi
    div ebx                // n/x
    add eax,ebx            // n/x+x
    shr eax,1              // (n/x+x)/2
    cmp eax,ebx
    jae OK
    mov ebx,eax
    jmp SQ_LOOP
  }
OK:
  __asm {
//    mov sq,ebx
    mov eax,ebx
  }
RET1:
#ifdef __BORLANDC__
  return _EAX ;
#else
  __asm mov n0,eax
  return n0 ;
#endif

}
