//
//  Copyright (C) by S.Tomabechi 1993,1994,1995
//  All rights reserved.
//
//  calculate Kronecker-Jacobi symbol
//
//  Sep 27 1995 write using assembler
//
#ifdef __BORLANDC__
#pragma inline
#endif

extern const long _Kr_tab[] ;

long Kronecker(const long a,const long b)
{
  long k(1) ;

  __asm {

    mov   ebx,b // ebx=b
    mov   ecx,a // ecx=a
    or    ebx,ebx
    jnz   Remove_2_from_b
    cmp   ecx,1           // a=1 ?
    je    abs_is_1
    cmp   ecx,-1          // a=-1 ?
    jne   abs_is_not_1
  }
abs_is_1:
  __asm jmp RET1
abs_is_not_1:
  __asm jmp RET0

Remove_2_from_b:          // (a/2)*...*(a/2)*(a/b')
                          // b=2*...*2*b'
  __asm {
    test  ecx,1           // a&1
    jnz   Remove_2        // a&1!=0
    test  ebx,1
    jz    abs_is_not_1    // a&1==0 && b&1==0
  }
Remove_2:
  __asm {
    xor edi,edi           // v:2 ̙pwJEg
  }
Remove_21:
  __asm {
    test  ebx,1
    jnz   Odd1
    inc   edi
    sar   ebx,1           // b /= 2
    jmp   Remove_21
  }
Odd1:
  __asm {
    and  edi,1
    jnz  Set_tab1         //  2 ܂܂Ă
    mov  k,1             //  2 ܂܂Ă
    jmp  b_is_negative
  }
Set_tab1:
  __asm {
    mov   eax,ecx
    and   eax,7           // a&7
    mov   eax,[_Kr_tab+eax*4]
    mov   k,eax
  }
b_is_negative:
  __asm {
    or    ebx,ebx
    jge   LOOP1           // b>=0
    neg   ebx             // b=-a
    or    ecx,ecx
    jge   LOOP1           // a>=0 
    neg   k               // k=-k
  }
LOOP1:
  __asm {
    or    ecx,ecx
    jnz   Remove_2_from_a // a!=0
    cmp   ebx,1           // b>1 ?
    jg    RET0            // b>1
    je    RETk            // b=1
  }
Remove_2_from_a:
  __asm {
    xor   edi, edi        // di=0
  }
Remove_23:                // (2/p)=(-1)^((p*p-1)/8)
  __asm {
    test  ecx,1           // Is a even ?
    jnz   Set_tab2        // a ͂͂łȂ
    inc   edi             // a ͋
    sar   ecx,1           // ͎ZpIVtgłȂ΂ȂȂ
    jmp   Remove_23
  }
Set_tab2:
  __asm {
    and   edi,1
    jz    Change_a_b      // skip if edi is even
    mov   eax,ebx
    and   eax,7           // b&7  b%=8
    mov   edi,eax
    mov   eax,dword ptr k
    imul  dword ptr [_Kr_tab+edi*4]  // k*_Kr_tab[b&7]

    mov   k,eax
  }
Change_a_b:               //(p/q)(q/p)=(-1)^((p-1)(q-1)/4)
  __asm {
    mov   eax,ecx
    and   eax,ebx
    test  eax,2
    jz    Swap
    neg   k               // k=-k
  }
Swap:
  __asm {
    or  ecx,ecx
    jge Calc_mod
    neg ecx               // a=-a
  }
Calc_mod:                 // calculate (b/a) instead of (a/b)
  __asm {
    mov eax,ebx
    cdq
    idiv ecx              // b%a
    xchg ecx,edx          // a<->b%a    (b/a)=(b%a/a)
    mov  ebx,edx          // b<-a
    jmp  LOOP1
  }

RET1:
  return 1 ;
RET0:
  return 0 ;
RETk:
  return k ;

}
