//
//  Copyright(C) by S.Tomabechi 1996
//  All rigts reserved.
//
//   calculate a*b mod m
//
#ifdef __BORLANDC__
#pragma inline
#endif
#include "Error.hpp"

long mod(const long a,const long b,const long m)
{
  __asm {
    mov  ebx,m
    or   ebx,ebx
    jg   POSITIVE
    jz   ERR                  // Is modulus m zero ?
    neg  ebx                  // postive modulus
  }
POSITIVE:
  __asm {
    mov  eax,a
    imul b
    idiv ebx
    or   edx,edx
    jge  OK                  // >=0
    add  edx,ebx             // positive remainder
  }
OK:
  __asm {
    mov m,edx
    jmp RET1
  }
ERR:
  Error(zero divide) ;
RET1:
  return m ;
}

