//
//	Copyright (C) by S.Tomabechi 1994-1996
//	All rights reserved.
//
//	multiplication by single precision integer
//
//	valid for this=&a
//
#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"

Mint& Mint::isMulUL(const Mint& a,const unsigned long n)
{

  int Count ;
  unsigned long Carry ;

  if( n==0 ) {
	__asm {
	  mov  esi,a
	  mov  edi,this
#ifdef __BORLANDC__
	  mov  byte ptr [edi.nDim+3],1
	  mov  dword ptr [edi.nDigit],0
	  mov  eax,[esi.fDigit]
	  mov  [edi.fDigit],eax
#else
	  mov  byte ptr [edi+SIGN],1
	  mov  dword ptr [edi+NDIGIT],0
	  mov  eax,[esi+FDIGIT]
	  mov  [edi+FDIGIT],eax
#endif
	  jmp  RET1
	}
  }


  if( ndim()<=a.nDigit ) {				// enlarge array
	if( this==&a ) reallocate(nDigit+1) ;
	else allocate(a.nDigit+1) ;
  }

  __asm {
	mov   esi,a
	mov   edi,this
#ifdef __BORLANDC__
	mov   ecx,[esi.nDigit]
	cmp   esi,edi			  // ͒lƖ߂l͓
	je	  TryMul

	mov   eax,[esi.nDigit]		// copy #digits and signature
	mov   [edi.nDigit],eax
	mov   eax,[esi.fDigit]
	mov   [edi.fDigit],eax
	mov   al,byte ptr [esi.nDim+3]
	mov   byte ptr [edi.nDim+3],al
#else
	mov   ecx,[esi+NDIGIT]
	cmp   esi,edi			  // ͒lƖ߂l͓
	je	  TryMul

	mov   eax,[esi+NDIGIT]		// CRs|
	mov   [edi+NDIGIT],eax
	mov   eax,[esi+FDIGIT]
	mov   [edi+FDIGIT],eax
	mov   al,[esi+SIGN]
	mov   [edi+SIGN],al
#endif
  }
TryMul:
  __asm {
	or	  ecx,ecx			  // =0 ?
	jz	  RET1				  // 搔͗

	mov   esi,[esi]
	mov   edi,[edi]

	mov   Count,ecx 		  // [vJE^
	mov   ecx,n
	xor   ebx,ebx
	mov   Carry,ebx
  }
Multiply:					  // multiply by n
  __asm {
	mov   eax,[ebx*NBYTE+esi]
	mul   ecx				  // *= n
	add   eax,Carry 		  // add carry from lower digit
	mov   [ebx*NBYTE+edi],eax
	adc   edx,0 			  // add carry

	mov   Carry,edx 		  // save carry
	inc   ebx
	dec   Count
	jnz   Multiply

	or	  edx,edx			  // overflow ?
	jz	  RET1
	mov   [ebx*NBYTE+edi],edx // save overflow
	mov   esi,this
#ifdef __BORLANDC__
	inc   dword ptr [esi.nDigit]  // increment #digits
#else
	inc   dword ptr [esi+NDIGIT]
#endif
  }

RET1:
  return *this ;

}
