//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  the smallest prime divisor of n
//
//  unsigned long n : (I) positive integer <2^32
//  return value    : the smallest prime divisor when n is composite
//                    1  when n is prime
//
//  ()ŏf߂
//
//   unsigend long n : 2^32 菬
//   ߂l  :  n ̍ŏf  n ̂Ƃ
//              1               n f̂Ƃ
//
#ifdef __BORLANDC__
#pragma inline
#endif
extern const unsigned char _t_[] ;
extern const unsigned char _small_prime_[] ;

unsigned long prmdiv(const unsigned long n)
{

  __asm {
    mov   ebx,n                     // ebx <- n fixed
    cmp   ebx,11
    ja    Check1
    mov   esi,4
  }
LOOP0:
  __asm {
    cmp   bl,[_small_prime_+esi]

    je    Prime0                    // n is one of small primes ?
    dec   esi
    jns   LOOP0
    cmp   bl,1
    je    Prime0
    jmp   Check1                    // n is one of {4,6,8,9,10}
  }
Prime0:
  __asm jmp Prime

Check1:                    // n >11
  __asm {
    mov   ecx,2           // 2 | n ?
    test  ebx,1
    jz    Factor0

    xor   edx,edx
    mov   eax,ebx
    mov   ecx,3
    div   ecx
    or    edx,edx           // n=0 mod 3 ?
    jz    Factor0

    xor   edx,edx
    mov   eax,ebx
    mov   ecx,5
    div   ecx
    or    edx,edx           // n=0 mod 5 ?
    jz    Factor0

    xor   edx,edx
    mov   eax,ebx
    mov   ecx,7
    div   ecx
    or    edx,edx           // n=0 mod 7  ?
    jz    Factor0

    xor   edx,edx
    mov   eax,ebx
    mov   ecx,11
    div   ecx
    or    edx,edx           // n=0 mod 11  ?
    jz    Factor0

    jmp   Try_division        // n is coprime to 2,3,5,7,11
  }
Factor0:
  __asm jmp Factor            // n is divisible by small prime

Try_division:                 // divide by odd numbers > 13
  __asm {
    mov   edi,47
  }
LOOP:
  __asm {
    inc   edi
    cmp   di,48
    jne   SKIP
    xor   edi,edi
  }
SKIP:
  __asm {
    movzx eax,byte ptr [_t_+edi]

    add   ecx,eax
    mov   eax,ebx        // eax <- n
    xor   edx,edx
    div   ecx            // Ă݂
    cmp   eax,ecx        // quotient < ecx ?
    jb    Prime
    or    edx,edx        // n=0 mod ecx ?
    jz    Factor
    jmp   LOOP           // try by next odd number
  }
Prime:
  __asm mov ecx,1        // n is prime
Factor:
#ifdef __BORLANDC__
  __asm mov eax,ecx

  return _EAX ;
#else
  __asm mov n,ecx
  return n ;
#endif

}

