//
//  Copyright (C) by S.Tomabeci 1996
//  All rights reserved.
//
//  Partition-exchange sort ( so called quick-sort )
//
//  sort an array of records
//
//  long _size   (I) number of records
//  long _length (I) size of a record (byte)  (must be multiple of 4)
//  long pos     (I) offset of key in record (byte)
//  long* record (I) address of array of records
//
//  L[ unsigned short ł郌R[hzɃ\[g
//  C ̃Cu quick sort  10{炢͑
//
//  long _size   (I) R[ȟ
//  long _length (I) R[h̑傫 (byte) 4 ̔{ł邱
//  long pos     (I) L[̈ʒu. 擪̃ItZbg (byte)
//  long* record (I) R[hz̐擪AhX
//

#ifdef __BORLANDC__
#pragma inline
#endif
extern long _stack_[] ;

void QSortULA(const long _size,const long _length,const long pos,unsigned long* record)
{
  long r,l(0) ;
  long M(8) ;
  long index ;
  long istack(0) ;
  long i,j ;
  unsigned long key ;

  __asm {
    dec  _size
    cmp  _size,0
    jle  RET1
    mov  eax,_size
    mul  _length
    mov  r,eax

    mov  eax,M
    mul  _length
    mov  M,eax

    mov  esi,record           // R|h̐擪AhX

    mov  edi,esi
    add  edi,pos              // rƂ pos 炵Ƃ

  }

MAIN_LOOP:
  __asm {
    mov eax,r
    sub eax,l
    cmp eax,M                 //  (r-l)<M ?
    jge STAGE1

//    cmp eax,0
    or  eax,eax
    jle POP_STACK

    mov eax,l                 // straight insertion sort
    add eax,_length
    mov index,eax
  }
LOOP1:
  __asm {
    mov  ebx,index
    mov  esi,record
    mov  ecx,_length
  }
MOVE:
  __asm {
    push dword ptr [ebx+esi]
    add  esi,4
    sub  ecx,4
    jnz  MOVE
  }

  __asm {
    mov  edx,[ebx+edi]   // ebx=k
    mov  key,edx
    sub  ebx,_length
  }
LOOP2:
  __asm {

      cmp  edx,[ebx+edi]   // eax=k-1
      jae  NEXT_LOOP

      mov  eax,ebx
      add  eax,_length
      mov  ecx,_length
      mov  esi,record
  }
MORE:
  __asm {
      mov  edx,[ebx+esi]
      mov  [eax+esi],edx
      add  esi,4
      sub  ecx,4
      jnz  MORE
      mov  edx,key
 }
NEXT:
  __asm {
      sub  ebx,_length
      cmp  ebx,l
      jge  LOOP2
  }
NEXT_LOOP:
  __asm {
    mov  ecx,_length
    mov  esi,record
    add  ebx,_length
    add  esi,_length
  }
MOVE2:
  __asm {
    sub  esi,4
    pop  dword ptr [ebx+esi]
    sub  ecx,4
    jnz  MOVE2
  }
  __asm {
    mov  ebx,index
    add  ebx,_length
    mov  index,ebx
    cmp  ebx,r
    jbe  LOOP1


  }
POP_STACK0:
  __asm {
   mov ebx,istack
//   cmp ebx,0
   or  ebx,ebx
   jg  POP_STACK
   jmp RET1                    // X^bNȂ̂ŏI
 }
POP_STACK:
  __asm {
   mov eax,[_stack_+ebx-4]
   mov r,eax

   mov eax,[_stack_+ebx-8]
   mov l,eax

   sub ebx,8

   mov istack,ebx
   jmp MAIN_LOOP


    }
STAGE1:
    __asm {
      mov eax,r                         // E
      add eax,l
      xor edx,edx
      div _length
      shr eax,1
      mul _length
      mov ebx,eax                       // ebx=(r+l)/2
      mov eax,l
      add eax,_length                    // eax=l+1
      mov esi,record
      mov ecx,_length
    }
C1:
      __asm {             // swap record[(l+r)/2] <-> record[l+1]
        mov  edx,[ebx+esi]
        xchg [eax+esi],edx
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C1

        mov  ebx,r                      // ebx=r
        mov  edx,[ebx+edi]   // edx=key[r]
        cmp  [eax+edi],edx   // key[l+1] > key[r] ?
        jbe  N1
        mov  esi,record
        mov  ecx,_length
      }
C2:
      __asm {             // swap record
        mov  edx,[ebx+esi]
        xchg [eax+esi],edx
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C2
      }
N1:
      __asm {
        sub  eax,_length                  // eax=l

        mov  edx,[ebx+edi]    // edx=key[r]
        cmp  [eax+edi],edx    // key[l]>key[r]
        jbe  N2
        mov  esi,record
        mov  ecx,_length
      }
C3:
      __asm {                            // swap record[l] <-> record[r]
        mov  edx,[ebx+esi]
        xchg [eax+esi],edx
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C3
      }
N2:
      __asm {
        mov  ebx,eax
        add  ebx,_length                 // ebx=l+1
        mov  edx,[ebx+edi]   // edx=key[l+1]
        cmp  edx,[eax+edi]   // key[l+1]>key[l]
        jbe  N3
        mov  esi,record
        mov  ecx,_length
      }
C4:
      __asm {
        mov  edx,[ebx+esi]
        xchg [eax+esi],edx
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C4

      }
N3:
    __asm {
      mov i,ebx         // i=l+1
      mov edx,[eax+edi]  // edx=key[l]
      mov key,edx
      mov ebx,eax       // ebx=l
      mov eax,r
      mov j,eax     // j=r
//      mov ebx,l
      mov esi,record
      mov ecx,_length
    }
MOVE4:
    __asm {
      push dword ptr [ebx+esi]
      add  ebx,4
      sub  ecx,4
      jnz  MOVE4
    }
SEARCH:
    __asm {
       mov edx,key
       mov eax,i
    }
SEARCH1:
      __asm {
        add eax,_length                // key[i]>=key ƂȂʒuT
        cmp edx,[eax+edi]
        ja  SEARCH1
      }
      __asm {
        mov i,eax

        mov eax,j
      }
SEARCH2:
      __asm {
        sub eax,_length
        cmp edx,[eax+edi]
        jb  SEARCH2
      }
      __asm {
        mov j,eax

        cmp eax,i   // j<i Ȃ烋[v甲
        jl  LEAVE_

        mov esi,record
        mov ecx,_length
        mov ebx,i
      }                        // Swap record[i]<->record[j]
C5:
      __asm {
        mov  edx,[ebx+esi]
        xchg [eax+esi],edx
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C5

        jmp  SEARCH
      }


LEAVE_:
    __asm {
        mov  esi,record
        mov  ecx,_length
        mov  ebx,l
        mov  eax,j
      }
C6:
      __asm {                             // record[l]=record[j]
        mov  edx,[eax+esi]
//        xchg dword ptr [eax+esi],edx
        mov  [ebx+esi],edx
        add  esi,4
        sub  ecx,4
        jnz  C6
    }

    __asm {
      mov  esi,record
      add  esi,_length
      mov  ecx,_length
      mov  ebx,j
    }
MOVE5:                                  // record[j] <- paritioning element
    __asm {
      sub  esi,4
      pop  dword ptr [ebx+esi]
      sub  ecx,4
      jnz  MOVE5
    }
    __asm {
      add istack,8
      mov ebx,istack
//cmp ebx,64*4
//jg ERROR
      mov eax,r
      add eax,_length
      sub eax,i                 // r-i+1

      mov edx,j
      sub edx,l                 // j-l

      cmp eax,edx
      jl  ELSE_
      mov eax,r
      mov [_stack_+ebx-4],eax    // push r
      mov eax,i
      mov [_stack_+ebx-8],eax    // push i
      mov eax,j
      sub eax,_length
      mov r,eax        // r=j-1
      jmp MAIN_LOOP

    }
ELSE_:
    __asm {
      mov eax,j
      sub eax,_length
      mov [_stack_+ebx-4],eax     // push j-1
      mov eax,l
      mov [_stack_+ebx-8],eax     // push l
      mov eax,i
      mov l,eax                              // l=i
      jmp MAIN_LOOP
    }

RET1:
//return ;
ERROR: ;
//cout << "stack overflow " ;
}