//
//  Copyright (C) by S.Tomabechi. 1993,1995,1997
//  All rights reserved.
//
//  square root by Newton's method
//
#ifdef __BORLANDC__
#pragma inline
#endif

#include "Fint.hpp"
#include <math.h>
#include "Error.hpp"

Fint& Fint::isSqrt(const Fint& a)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
#endif
  switch( sign(a) ) {
    case -1:                        // a is negative
      Error(negative number) ;
    case 0:                         // a is zero
      return *this=a ;
    default:                        // a is positive
      break ;
  }


  int anDigit ;
  int afDigit ;
  int shift ;
  int precision ;
  int t(3) ;
  Fint* aa ;
  bool same(false) ;

  __asm {
    mov  esi,a
    cmp  esi,this
    sete same
    mov  aa,esi
#ifdef __BORLANDC__
    mov eax,[esi.nDigit]
    mov anDigit,eax
    mov ecx,[esi.fDigit]
    add eax,t                         // ʂ𗚂
    mov [esi.fDigit],eax    // =0 ̎ɕϊ
    mov afDigit,ecx
    mov precision,eax
    sub eax,ecx
    mov shift,eax                     // shift=a.nDigit-a.fDigit-1
#else
    mov eax,[esi+NDIGIT]
    mov anDigit,eax
    mov ecx,[esi+FDIGIT]
    add eax,t
    mov [esi+FDIGIT],eax
    mov afDigit,ecx
    mov precision,eax
    sub eax,ecx
    mov shift,eax
#endif
  }

  Fint s ;
  if( same ) {                // ߂lƃp^
    aa=&Fint::_vFtemp ;
    aa->operator=(a) ;        // p^Rs[
  }
  else {
    aa=&((Fint&)a) ;
  }

#ifdef _MEMMAN_DEBUG
aa->check(__FILE__,__LINE__) ;
#endif

  if( anDigit<=FFT_digit ) {
    fDigit=precision ;
#ifndef __LINUX__
  #ifdef __BORLANDC__
    *this=1.0/sqrtl((long double)(*aa)) ; // sqrtl(long double) ŋߎ
  #else
    fDigit=precision ;
    double tld=double(*aa) ;
    tld=1.0/sqrt(tld) ;

    *this=tld ;
  #ifdef _MEMMAN_DEBUG
  check(__FILE__,__LINE__) ;
  #endif
  #endif
#else
    fDigit=precision ;
    double tld=double(*aa) ;
    tld=1.0/sqrt(tld) ;

    *this=tld ;
#endif
  }
  else {
    ((Mint*)this)->isShift32((Mint&)(*aa),FFT_digit-anDigit-1) ;
//if(*this==0 ) Error(*this==0) ;
//  ((Mint*)this)->isShift32((Mint&)(*aa),FFT_digit-anDigit) ;
    isSqrt(*this) ;
//if(*this==0 ) Error(*this==0) ;
//cout << endl << this->fDigit;
//cout << endl << Fint(*this)[-fDigit+10]   ;
//cout << endl << this->fDigit;
    isDivF(1UL,*this) ;
//    isInverse(*this) ;
//cout << endl << Fint(*this)[-fDigit+2]    ;
    ((Mint*)this)->isShift32((Mint&)(*this),precision-fDigit) ;
//cout << endl << Fint(*this)[-fDigit+2] << flush   ;
  }

                                     // compute square root by Newton method
  for(;;) {
//    s.isSquare(*this) ;           // MȂ̂
    s.isMulF(*this,*this) ;
//cerr << endl <<s.ndigit() << " /" << anDigit << flush ;
    s*=(*aa) ;
    (++(~s))>>=1 ;                   // s=(1-s)/2
//cerr << endl <<s.fdigit() << " /" << anDigit << flush ;
    if( s.ndigit()<t+anDigit*5/100 ) break ;         // Ȃ ?
    else { s*=(*this) ; (*this)+=s ; }
//cerr << endl << Fint(*this)[-fDigit+2]    ;
//cerr << endl <<s.ndigit() << " /" << anDigit << flush ;
  }
                                     //  u *= a
  isMulF(*this,*aa) ;
                                     // a Ƃ̒lɖ߂
  if( !same ) {
  __asm {
      mov esi,a
      mov eax,afDigit
#ifdef __BORLANDC__
      mov [esi.fDigit],eax
#else
      mov [esi+FDIGIT],eax
#endif
    }
  }


  if( shift>0 ) {                    // _ʒu炷
    fDigit-=(shift>>1) ;
    if( shift&1 ) *this<<=16 ;
  }
  else if( shift<0 ) {
    fDigit += -shift/2 ;
    if( shift&1 ) *this>>=16 ;
  }

//  return u[a.fDigit-u.fDigit]  ;
     // ۂ߂ĕԂDxIɂ͂̕悢낤D
     // ̂ŕԂƁC^l菬lōł悢ߎlԂ낤D
#ifdef _MEMMAN_DEBUG
//_MemMan.check(__FILE__,__LINE__) ;
check(__FILE__,__LINE__) ;
#endif
  return isRound(*this,afDigit) ;
}
