//
//  Copyright (C) by S.Tomabechi 1995,1999
//  All rights reserved.
//
//  square root mod p
//
//  f p   a ɂ p @Ƃ a ̕ x
//
//      x^2=a mod p
//
//  ߂.
//  ̊֐𗘗pƂ, Kronecker-Jacobi L g
//   a  p Ɋւĕ]ł邱Ƃm߂Ă.
//  (a/p)=1  ̂ƂԂ. (a/p)=-1 ̂Ƃ̓|v邩mȂ.
//
#ifdef __BORLANDC__
#pragma inline
#endif
#include <iostream.h>
#include <iomanip.h>
long power(const long x,const unsigned long n,const long p) ;
long Kronecker(const long a,const long n) ;

long sqrt(const long a,const long p)
{

  long q ;
  long r ;

  __asm {
    mov   ebx,p               // ebx <- abs(p)
    or    ebx,ebx
    jge   Check_a
    neg   ebx
    mov   p,ebx
  }
Check_a:
  __asm {
    mov eax,a   // a ŏ]ɂ
    cdq
    idiv ebx
    or  edx,edx
    jg  OK
    jl  NEGATIVE
    jmp RET0             // a=0 Ȃ 0 Ԃ
  }
NEGATIVE:
  __asm {
    add edx,ebx
    mov a,edx
  }
OK:
  __asm {
    mov eax,ebx
    and eax,3
    cmp eax,3
    jne mod8
    jmp RET1
  }

mod8:
  __asm {
    mov eax,ebx
    and eax,7
    cmp eax,5
    jne CASE1
    jmp CASE5
  }
CASE1:
  __asm {
    cmp eax,1
    je  Shanks
    jmp RETa
  }
Shanks:
  __asm {
    xor esi,esi
    mov eax,ebx
    dec eax
  }
EVEN_1:
  __asm {
    test eax,1
    jnz  EXIT_LOOP
    inc esi
    shr eax,1
    jmp EVEN_1
  }
EXIT_LOOP:
  __asm {
    mov r,esi
    mov q,eax                 // p-1=2^r*q
  }

   long nn(p) ;
   long n ;
Find_generator:               // 𔭐

   __asm {
     mov eax,nn
     mov ebx,1664525
     mul ebx
     add eax,1013904223
     mov nn,eax
     xor edx,edx
     div p
     and edx,0x7fffffff
     mov n,edx
   }
   if( Kronecker(n,p)!=-1 ) goto Find_generator ;
//Initialize:
  long y=power(n,q,p) ;
  q=power(a,(q-1)>>1,p) ;

  __asm {
    mov ebx,p             // ebx <- p ȌŒ
    mov eax,q             // x=q
    mul eax               //  x*x
    div ebx               //  edx <- (x*x) mod p
    mov eax,a
    mov ecx,eax
    mul edx               //  a*((x*x) mod p)
    div ebx               //  mod p
    mov a,edx             // a=b

    mov eax,q
    mul ecx               // * a
    div ebx
    mov q,edx             // x <- x*a mod p
  }
LOOP_1:
  __asm {
    mov eax,a
    cmp eax,1
    je  RETq
    mul eax               // b*b
    div ebx               // edx <- b*b mod p
    mov edi,1
  }
IS_1:
  __asm {
    cmp edx,1             // b2=1 ?
    je  LEAVE_1
    mov eax,edx
    mul edx               // eax <- eax *eax
    div ebx               // mod p   edx=b^2
    inc edi
    jmp IS_1
  }
LEAVE_1:
  __asm {
    cmp edi,r
    je  RET00
    mov eax,y
    mov edx,eax
    mov ecx,r
    sub ecx,edi
    dec ecx
    jz  MUL_LOOP_END
  }
MUL_LOOP:
  __asm {
    mul eax
    div ebx
    mov eax,edx
    dec ecx
    jnz MUL_LOOP
  }
MUL_LOOP_END:
  __asm {
    mov esi,edx
    mov eax,esi
    mul esi
    div ebx
    mov y,edx   // y <- (t^2)%p

    mov eax,a   //
    mul edx
    div ebx
    mov a,edx   // b<-(b*y)%p

    mov r,edi   // r <- m

    mov eax,q
    mul esi
    div ebx
    mov q,edx
    jmp LOOP_1
  }

RETq:
  return q ;
RET00:
  goto RET0 ;

CASE5:
  if( power(a,(p-1)>>2,p)==1 ) {
    return power(a,(p+3)>>3,p) ;
  }
  else {
            // (2*a*power(4*a,(p-5)/8,p))%p ߂
            // rŒPxɎ܂Ȃ߃AZugp
    __asm {
      mov   eax,a
      xor   edx,edx
      shld  edx,eax,2
      shl   eax,2
      div   p
      mov   r,edx
    }

    q=power((unsigned long)r,(unsigned long)((p-5)>>3),(unsigned long)p) ;
    __asm {
      mov ecx,p
      mov eax,q
      mul a
      div ecx
      mov eax,edx
      xor edx,edx
      shld edx,eax,1
      shl  eax,1
      div ecx
      mov q,edx
      jmp RETq
    }
  }
RET0:
  return 0 ;
RETa:
  return a ;
RET1:
  return power(a,(p+1)>>2,p) ;
}


