//
//  Copyright (C) by S.Tomabechi 1993,1997
//  All rights reserved.
//
//  calculate power mod p (Βlŏ]ŌvZ)
//
//  1997/03/11
//     dx/2 ̉Z炷߂ɌƑȍHv
//
//  1997/05/30
//     pŵƂ́Amod p ł̋t̙pvZ悤ɂ
//
#ifdef __BORLANDC__
#pragma inline
#endif

#include "Mint.hpp"
#include "Error.hpp"

Mint& Mint::apower(const Mint& x,const Mint& n,const Mint& p)
{
  long j(0),k ;
  unsigned long d ;
  long leng=ilog2(n) ;

  if( !n.isNegative() ) _uuMtemp=x ;   // n>=0
  else {
    _uuMtemp.isInvModp(x,p) ;          // inverse x^-1 mod p
    if( _uuMtemp.isZero() ) Error(x is zerodivisor) ;
  }

#ifdef WIN32
  __asm {                              // *this <- 1
    mov esi,this
    mov eax,1
  #ifdef __BORLANDC__
    mov [esi.nDigit],eax
    mov [esi.nDim+3],al
    mov esi,[esi]
    mov [esi],eax
  #else
    mov [esi+NDIGIT],eax
    mov [esi+SIGN],al
    mov esi,[esi]
    mov [esi],eax
  #endif
  }
#else
  *this=1 ;
#endif

  if( leng>=0 ) for(;;) {
    d=n.digit[j++] ;
    for( k=32 ; k!=0 ; k-- ) {
      if( d&1 ) ((*this)*=_uuMtemp)^=p ;  // Βlŏ]
      if( --leng<0 ) goto RET1 ;
      d>>=1 ;                             // n/=2
      _uuMtemp.isSquare(_uuMtemp)^=p ;    // x*x mod p
    }
  }
RET1: ;
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif
  return *this ;

}

