//
//  Copyright (C) 1995 by S.Tomabechi
//  All rights reserved.
//
//  Primarity test by Adleman-Pomerance-Rumely
//
//   fǂ𔻒
//
//    ߂l   true  : f
//             false : fłȂ
//
#define _ONLY_MintDECL_
#include "Mint.hpp"
#include "TBit.hpp"
#include "MBit.hpp"

#include "Error.hpp"

static short wk ;
static short et ;

const short maxP=17 ;
short nQ ;
short nP ;
short WK[7][28] ;
short Eta[7][28] ;
static short P[]={2,3,5,7,11,13,17} ;
short Q[]={3,7,11,31,
         43,71,211,
         23,67,331,463,2311,
         79,131,547,859,911,2003,2731,6007,
         103,239,443,1123,1327,1871,3571,9283} ;
// primitive root of Q
short G[]={2,3,2,3,
         3,7,2,
         5,2,3,3,3,
         3,2,2,2,17,5,3,3,
         5,7,2,2,3,14,2,2 } ;
Mint Tau[maxP] ;
Mint Tau1[maxP] ;
Mint Tau2[maxP] ;
Mint Tau_e[maxP] ;
Mint Sum[maxP] ;
Mint Tau_p[maxP] ;
short* index ;
short* Psi ;
short* Phi ;


short Test4_2(Mint& u) ;
bool Test3_2(const Mint& N) ;
bool Test2_2(short q,const Mint& N) ;
bool Test5_2(short q,Mint& u,const Mint& N) ;
short Test4_p(short p,Mint& u,const Mint& N) ;

bool Test3_p(short p,const Mint& N) ;
bool Test2_p(short p,short q,short g,short sw,const Mint& N) ;
bool Test5_p(short p,Mint& u,const Mint& N) ;
Mint GetV(void) ;
void T1_T1(short p,const Mint& N) ;
void T_T1(short p,const Mint& N) ;
bool W_chi(short p,const Mint& N) ;
void Psi_Psi(short p,short q,const Mint& N) ;
void Phy_Psi(short p,short q,const Mint& N) ;
void Tau_P(short p,short q,const Mint& N) ;
void T_E(short p,Mint& E,const Mint& N) ;
void Jacobi(short p,short q,short e,const Mint& N) ;
void T_TM(short p,const Mint& N) ;

#include "MintFunc.hpp"

bool APR(const Mint& N)
{
  short j,k ;
  short h ;
  short mw ;
  short sw ;
  Mint res ;
  unsigned long w ;
  Mint W ;
  Mint V ;
  Mint T ;
  Mint u(N) ;
  bool isPrime ;

  Mint s(1) ;
  for( nQ=0 ; nQ<=27 ; nQ++ ) {
    s*=Q[nQ] ;
    if( s*s>N ) goto OK ;
  }
  Error(too big number) ;
OK: ;
  for( k=0,j=0 ; j<=nQ ; j++ ) k=k>Q[j] ? k:Q[j] ;

  index=new short[k] ; index[0]=0 ;
  Psi=new short[k] ;
  Phi=new short[k] ;

  nP=2+(nQ>3)+(nQ>6)+(nQ>11)+(nQ>19) ;

//cout << endl << "prmdiv " << prmdiv(N) ;

  w=prmdiv(N) ;
  if( w==1 ) goto All_OK ;          // N is prime
  else if( w!=0 ) goto Factor ;     // N has small factor

             // N-1=2^h*u
//cout << endl << "Test for p=2 " ;
  if( (h=Test4_2(u))==1 ) sw=true ;
  else sw=Test3_2(N) ;      // Check condition 3 for p=2
//cout << endl << "post Test4_2 u " << u ;

  mw=1 ;
  for( j=0 ; j<=nQ ; j++ ) {
//cout << endl << "test2_2 " ;
    if( !Test2_2(Q[j],N) ) goto Failed ;
    if( sw ) wk=h ;
    else if( !Test5_2(Q[j],u,N) ) goto Factor ;

    WK[0][j]=wk ;
    Eta[0][j]=et ;
    if( wk>mw ) mw=wk ;
  }

//  decide max of W and eta(chi)
  if( mw!=1 ) {
    for( j=0 ; j<=nQ ; j++ ) {
      if( mw>WK[0][j] ) Eta[0][j]=0 ;
    }
  }

//
// Test for p>2
//
  for( k=1 ; k<=nP ; k++ ) {
//cout << endl << "test for p= " << P[k] ;
    if( Test4_p(P[k],u,N)==1 ) sw=true ;
    else sw=Test3_p(P[k],N) ;

    mw=1 ;
    for( j=0 ; j<=nQ ; j++ ) {
      if( (Q[j]-1)%P[k] ) {
        wk=0 ;
        et=0 ;
        goto Set_Eta ;
      }

//cout << endl << " test2_p" ;
      if( !Test2_p(P[k],Q[j],G[j],sw,N) ) goto Failed ;

      if( sw ) {
        wk=h ;
        et=index[N%Q[j]]%P[k] ;
        goto Set_Eta ;
      }
//cout << endl << "test5_p " ;
      if( !Test5_p(P[k],u,N) ) goto Failed ;

Set_Eta: ;
      WK[k][j]=wk ;
      Eta[k][j]=et ;
      if( wk>mw ) mw=wk ;
    }
// decide max of W and eta(chi)
    if( mw!=1 ) {
      for( j=0 ; j<=nQ ; j++ ) {
        wk=WK[k][j] ;
        if( wk ) {
          if( mw>wk ) Eta[k][j]=0 ;
        }
      }
    }

  }

// Final Test
  V=GetV() ;

  W=1 ;
  T=1 ;
  for( j=0 ; j<=nP ; j++ ) T *= P[j] ;
  while( T!=0 ) {
    W=mod(W*V,N) ;
    if( W==1 ) goto All_OK ;
    if( N%W==0 ) goto GetFactor ;
    --T ;

  }

All_OK: ;
  isPrime=true ;
  goto RET ;
Factor: ;
  isPrime=false ;
  goto RET ;
Failed: ;
  isPrime=false ;
  goto RET ;
GetFactor: ;
  isPrime=false ;
RET: ;
  delete [] index ;
  delete [] Psi ;
  delete [] Phi ;

  return isPrime ;
}


// check condition 3 for p=2
bool Test3_2(const Mint& N)
{
  for( short j=0 ; j<=nQ ; j++ )
    if( Kronecker(N%Q[j],long(Q[j]))!=1 ) return true ;
  return false ;
}

//
// Check condition 4 for p=2
//
//  N-1=2^h*u
//
short Test4_2(Mint& u)
{
  --u ;
  for( short h=0 ;;h++) {
    if( ((unsigned long)u)&1 ) return h ;  // odd
    u>>=1 ;
  }
}

// Check condition 2 for p=2
bool Test2_2(short q,const Mint& N)
{
  Mint W ;


  if( (q-1)&3 ) W=N-q ;
  else W=q ;

  Mint u=power(W,(N-1)>>=1,N) ;
  if( Kronecker(N%q,long(q))<0 ) {
    et=1 ;
    return (u==N-1) ;
  }
  else {
    et=0 ;
    return u==1 ;
  }
}

//
// Check condition 5 for p=2
//
bool Test5_2(short q,Mint& u,const Mint& N)
{
  Mint T=Kronecker(-1,long(q))*q ;    // tau^2
  Mint W ;
//cout << endl << "u " << u ;
  T=power(T,u,N) ;
  wk=1 ;
  et=0 ;
  if( T==1 ) return true ;
  if( T==N-1 ) { et=1 ; return true ; }
//cout << endl << N ;
//cout << endl << "T " <<  T ;
  do {
    wk++ ;
    W=T ;
    T=mod(W*W,N) ;
    if( T==(N-1) ) { et=1 ; return true ; }
//cout << endl << T ;
  } while( T!=1 ) ;

  if( gcd(W,N)==1 ) return true ;
  else return false ;
}

// subroutines for P>2
// Check condition 3 for p>2
//
// N^((q-1)/p^k)=1 mod q
//
bool Test3_p(short p,const Mint& N)
{
  short q,e,res ;
  for( short j=0 ; j<=nQ ; j++ ) {
    q=Q[j] ;
    e=(q-1)/p ;
    res=(q-1)%p ;
    if( res==0 ) {
      if( power(N%q,(unsigned long)e,long(q))!=1 ) return true ;
    }
  }
  return false ;
}


// N^(p-1)-1=p^h*u
short Test4_p(short p,Mint& u,const Mint& N)
{
  u=power(N,p-1)-1 ;
  for( short h=0 ; ; h++ ) {
    if( u%p ) return h ;
    u/=p ;
  }
}

// Check condition 2 for p>2
// calculation of tau(chi)^n/tau(chi^n)
//
bool Test2_p(short p,short q,short g,short sw,const Mint& N)
{
  long k ;
  short j ;
//cout << endl << " p q g " << p << " " << q << " " << g ;
               // calculate index
  for( k=1,j=1 ; j<q ; j++ ) {
//    k *= g%q ;
//    k=(k*long(g))%long(q) ;
    k=mod(k,g,q) ;    // k*g mod q
    index[k]=j%p ;
  }

  Tau_P(p,q,N) ;

  if( !sw ) for( j=0 ; j<=p-2 ; j++ ) Tau_p[j]=Tau[j] ;

  Mint E=N/p ;
  T_E(p,E,N) ;


  for( j=0 ; j<=p-2 ; j++ )
    Tau_e[j]=Tau[j] ;

  short e=short(N%p) ;
  Jacobi(p,q,e,N) ;

  T_TM(p,N) ;


// Main of Test2

  Mint W ;
  e=(short)mod(-index[N%q]*N,p) ;
  if( e==p-1 ) W=-(N-1)*(p-1) ;
  else {
    if( Tau[e]!=1 ) return false ;
    --Tau[e] ;
    W=0 ;
  }
  for( j=0 ; j<=p-2 ; j++ ) {
    W+=Tau[j] ;
  }
  return W==0 ;
}


// Check conditon 5 for P>2

// calculation of tau(chi)^p^u
//
bool Test5_p(short p,Mint& u,const Mint& N)
{
  short j ;
  MBit B ;
  TBit T ;
  Mint W ;

  for( j=0 ; j<=p-2 ; j++ ) Tau1[j]=Tau_p[j] ;

  Tau[0]=1 ;
  for( j=1 ; j<=p-2 ; j++ ) Tau[j]=0 ;

//  B.SetBitString(ilog2(u)+1,u.digit) ;
//  B.SetBitString(u) ;
  B=u ;
  for( j=0 ; j<=ilog2(u)-1 ; j++ ) {
    if( B[j] ) T_T1(p,N) ;
    T1_T1(p,N) ;
  }
  T_T1(p,N) ;
  // check condition 5 by making tau(chi)^p^u
  wk=1 ;

  if( W_chi(p,N) ) return true ;
  unsigned long Up=p ;
  T.SetBitString(32,&Up) ;
  for(;;) {
    for( j=0 ; j<=p-2 ; j++ )
      Tau1[j]=Tau[j] ;
    for( j=0 ; j<=p-2 ; j++ )
      Tau_e[j]=Tau[j] ;
    for( j=1 ; j<=ilog2(p)-1 ; j++ ) {
      T1_T1(p,N) ;
      if( T[j] ) T_T1(p,N) ;
    }
    T1_T1(p,N) ;
    T_T1(p,N) ;
    wk++ ;
    if( W_chi(p,N) ) break ;
  }
  if( et>0 ) return true ;

// Main of test 5
  for( j=0 ;;j++) {

    if( gcd(Tau_e[j],N)==1 ) break ;
    if( Tau_e[j]!=0 ) { W=gcd(Tau_e[j],N) ; return false ; }
  }

  if( Tau_e[j]!=1 ) {
    if( gcd(Tau_e[j]-1,N)!=1 ) {
      W=gcd(Tau_e[j]-1,N) ;
      return false ;
    }
  }
  else {
    for( j++ ;; j++ ) {
      if( gcd(Tau_e[j],N)!=1 ) {
        if( Tau_e[j]!=0 ) {
          W=gcd(Tau_e[j],N) ;
          return false ;
        }
      }
      else break ;
    }
  }

  for( j=0 ; ; j++ ) {
    if( gcd(Tau_e[j]+1,N)==1 ) return true ;
    if( Tau_e[j]<N-1 ) {
      W=gcd(Tau_e[j],N) ;
      return false ;
    }
  }

}


bool W_chi(short p,const Mint& N)
{
  Mint W ;
  short j ;
  if( Tau[0]<=1 ) {
    W=Tau[0] ;
    et=0 ;
    for( j=1 ; j<=p-2 ; j++ ) {
      if( Tau[j]!=0 ) {
        W+=Tau[j] ;
        et=j ;
      }
    }
    return W==1 ;
  }
  else if( Tau[0]<N-1 ) return false ;
  else {
    for( j=1 ; j<=p-2 ; j++ ) {
      if( Tau[j]<Tau[0] ) return false ;
    }
    et=p-1 ;
    return true ;
  }
}


void Tau_P(short p,short q,const Mint& N)
{
  Mint W ;
  short j,k,l ;

  for( j=1 ; j<q ; j++ ) Psi[j]=index[j] ;
  for( j=1 ; j<q ; j++ ) Phi[j]=index[j] ;

  Tau[0]=1 ;
  for( j=1 ; j<=p-2 ; j++ ) Tau[j]=0 ;

  Tau1[0]=1 ;
  for( j=1 ; j<=p-2 ; j++ ) Tau1[j]=0 ;

  TBit B ;
  unsigned long _p=p ;
  B.SetBitString(32,&_p) ;
  for( j=1 ; j<=ilog2(_p)-1 ; j++ ) {
    Psi_Psi(p,q,N) ;
    if( B[j] ) Phy_Psi(p,q,N) ;
  }

  Psi_Psi(p,q,N) ;


  T_T1(p,N) ;

  for( j=0 ; j<=p-2 ; j++ ) Tau1[j]=Tau[j] ;

  Tau1[p-1]=0 ;
  k=Phi[q-1] ;
  for( j=0 ; j<p ; j++ ) {
    l=(j+k)%p ;
    Tau[l]=Tau1[j] ;
  }
  W=Tau[p-1] ;
  for( j=0 ; j<=p-2 ; j++ ) {
    Tau[j]=mod((Tau[j]-W)*q,N) ;
  }

}

// calculation of T^E
void T_E(short p,Mint& E,const Mint& N)
{
  short j,k ;

  MBit B ;
  long leng=ilog2(E) ;
//  B.SetBitString(E) ;
  B=E ;
  for( j=0 ; j<=p-2 ; j++ ) Tau1[j]=Tau[j] ;
  j=0 ;
  if( !(((unsigned long)E)&1) ) {
    for( j=0 ; !B[j] ; j++ ) {
      T1_T1(p,N) ;
    }
    for( k=0 ; k<=p-2 ; k++ ) Tau[k]=Tau1[k] ;
  }
  for( j++ ; j<=leng ; j++ ) {
    T1_T1(p,N) ;
    if( B[j] ) T_T1(p,N) ;
  }
}


void Jacobi(short p,short q,short e,const Mint& N)
{
  short j,k ;
  TBit B ;
  unsigned long _e=e ;

  for( j=0 ; j<=q-1 ; j++ ) Psi[j]=index[j] ;

  Tau1[0]=1 ;
  for( j=1 ; j<=p-2 ; j++ ) Tau1[j]=0 ;

  B.SetBitString(32,&_e) ;

  for( k=0 ; !B[k] ; k++ ) {
    Psi_Psi(p,q,N) ;
  }

  for( j=0 ; j<=p-2 ; j++ )
    Tau[j]=Tau1[j] ;

  for( j=0 ; j<=q-1 ; j++ )
    Phi[j]=Psi[j] ;

  for( k++ ;k<=ilog2(e) ; k++ ) {
    Psi_Psi(p,q,N) ;
    if( B[k] ) Phy_Psi(p,q,N) ;
  }

}

// calculation of T=T*TM

void T_TM(short p,const Mint& N)
{
  int j,k,l ;

  for( j=0 ; j<=p-2 ; j++ )
    Tau2[j]=mod(Tau[0]*Tau_e[j],N) ;
  Tau2[p-1]=0 ;

  for( k=1 ; k<=p-2 ; k++ ) {
    for( j=0 ; j<=p-2 ; j++ ) {
      l=(k+j)%p ;
      Tau2[l] += mod(Tau[k]*Tau_e[j],N) ;
    }
  }

  Mint W ;
  W=Tau2[p-1] ;
  for( j=0 ; j<=p-2 ; j++ ) Tau[j]=mod(Tau2[j]-W,N) ;
  for( j=0 ; j<=p-2 ; j++ ) Tau2[j]=Tau[j] ;
}


void Psi_Psi(short p,short q,const Mint& N)
{
  short j,k,l ;
  Mint W ;

  for( j=0 ; j<p ; j++ ) Sum[j]=0 ;
  for( j=2 ; j<q ; j++ ) {
    Sum[(Psi[j]+Psi[q+1-j])%p]++ ;
  }

// calculation of T1=T1*T1*U
  for( j=0 ; j<=(p-1)/2 ; j++ )
    Tau2[2*j]=mod(Tau1[j]*Tau1[j],N) ;

  for( j=(p+1)/2 ; j<=p-2 ; j++ )
    Tau2[2*j-p]=mod(Tau1[j]*Tau1[j],N) ;

  Tau2[p-2]=0 ;

  for( k=0 ; k<=p-3 ; k++ ) {
    for( j=k+1 ; j<=p-2 ; j++ ) {
      l=(j+k)%p ;
      Tau2[l]+=mod(2*Tau1[k]*Tau1[j],N) ;
    }
  }

  for( j=0 ; j<=p-1 ; j++ )
    Tau1[j]=mod(Tau2[0]*Sum[j],N) ;

  for( k=1 ; k<=p-1 ; k++ ) {
    for( j=0 ; j<=p-1 ; j++ ) {
      l=(j+k)%p ;
      Tau1[l]+=mod(Tau2[k]*Sum[j],N) ;
    }
  }

  W=Tau1[p-1] ;
  for( j=0 ; j<=p-2 ; j++ )
    Tau1[j]=mod(Tau1[j]-W,N) ;

// calculation of Psi^2
  for( j=0 ; j<=q-1 ; j++ )
    Psi[j]=(2*Psi[j])%p ;

}

void Phy_Psi(short p,short q,const Mint& N)
{
  Mint W ;
  short j,k,l ;
  for( j=0 ; j<=p-1 ; j++ ) Sum[j]=0 ;

  for( j=2 ; j<=q-1 ; j++ ) {
    Sum[(Phi[j]+Psi[q+1-j])%p]++ ;
  }

// calculation of T=T*T1*SU
  for( j=0 ; j<=p-2 ; j++ ) {
    Tau2[j]=mod(Tau[0]*Tau1[j],N);
  }
  Tau2[p-1]=0 ;

  for( k=1 ; k<=p-2 ; k++ ) {
    for( j=0 ; j<=p-2 ; j++ ) {
      l=(j+k)%p ;
      Tau2[l] += Tau[k]*mod(Tau1[j],N) ;
    }
  }

  for( j=0 ; j<=p-1 ; j++ ) {
    Tau[j]=mod(Tau2[0]*Sum[j],N) ;
  }

  for( k=1 ; k<=p-1 ; k++ ) {
    for( j=0 ; j<=p-1 ; j++ ) {
      l=(j+k)%p ;
      Tau[l]+=mod(Tau2[k]*Sum[j],N) ;
    }
  }
  W=Tau[p-1] ;
  for( j=0 ; j<=p-2 ; j++ )
    Tau[j]=mod(Tau[j]-W,N) ;

// calculation of PHY=PHY*PHY
  for( j=0 ; j<=q-1 ; j++ ) {
    Phi[j]=(Phi[j]+Psi[j])%p ;
  }
}


void T_T1(short p,const Mint& N)
{
  Mint W ;
  short j,l ;
  long k ;

  for( j=0 ; j<=p-2 ; j++ ) {
    Tau2[j]=mod(Tau[0]*Tau1[j],N) ;
  }
  Tau2[p-1]=0 ;
  for( k=1 ; k<=p-2 ; k++ ) {
    for( j=0 ; j<=p-2 ; j++ ) {
      l=(j+k)%p ;
      Tau2[l]+=mod(Tau[k]*Tau1[j],N) ;
    }
  }

  W=Tau2[p-1] ;
  for( j=0 ; j<=p-2 ; j++ )
    Tau[j]=mod(Tau2[j]-W,N) ;
}


// calculation of T1=T1*T1
void T1_T1(short p,const Mint& N)
{
  short j,k,l ;
  Mint W ;
  for( j=0 ; j<=(p-1)/2 ; j++ )
    Tau2[2*j]=mod(Tau1[j]*Tau1[j],N) ;

  for( j=(p+1)/2 ; j<=p-2 ; j++ )
    Tau2[2*j-p]=mod(Tau1[j]*Tau1[j],N) ;

  Tau2[p-2]=0 ;

  for( k=0 ; k<=p-3 ; k++ ) {
    for( j=k+1 ; j<=p-2 ; j++ ) {
      l=(j+k)%p ;
      Tau2[l]+=mod(2*Tau1[k]*Tau1[j],N) ;
    }
  }

  W=Tau2[p-1] ;
  for( j=0 ; j<=p-2 ; j++ )
    Tau1[j]=mod(Tau2[j]-W,N) ;

}

//
// subroutine for the final test
//
// calculation of V mod S
Mint GetV(void)
{
  short j,k,x ;
  Mint  p ;
  Mint U1,V1,M1 ;
  Mint IN,V ;
  for( j=0 ; j<=nQ ; j++ ) {
    IN=Eta[0][j] ;
    p=2 ;
    for( k=1 ; k<=nP ; k++ ) {
      if( !WK[k][j] ) continue ;
      U1=p*invmodp(long(p%long(P[k])),long(P[k])) ;
      V1=1-U1 ;
      p*=P[k] ;
      IN=mod(IN*V1+Eta[k][j]*U1,p) ;
    }
    x=(short)power(long(G[j]),(unsigned long)IN,long(Q[j])) ;
    if( j!=0 ) {
      U1=M1*invmodp(M1%long(Q[j]),long(Q[j])) ;
      V1=1-U1 ;
      M1*=Q[j] ;
      V=mod(V*V1+x*U1,M1) ;
    }
    else {
      M1=Q[j] ;
      V=x ;
    }
  }
  return V ;
}
