//
//  Copyright (C) by S.Tomabechi 2001
//  All rights reserved.
//
//  Algorithm 9.1.29 (Divisors in Residue classes). Let r,s,N be integers
//  such that 0<= r < s < N (r,s)=1 and s > cubrt(N). This algorithm determines
//  all the divisors d of N such that d=r mod s

#include "Mint.hpp"
#include "Fint.hpp"
#include <iostream.h>
#include <vector.h>
#include "Error.hpp"
using namespace std ;

bool div_res(Mint& r,Mint& s,Mint& N,Mint& d)
{
    Mint u,v ;
//    Mint d ;
    Mint s2=s*s ;
    Mint s3=s2*s ;

// Initilalization
#if 1
    d=egcd(r,s,u,v) ;   // extended Euclid's algorithm
    if( d!=1 ) return true;
//    if( s3<=N ) return false ;  // ̏͏Oł̂ł ?

    Mint rp=u*N&s ;
//    if( rp<r ) return false ;
#endif
    Mint a0=s ;
    Mint b0(0) ;
    Mint c0(0) ;
    Mint c ;
    Mint a1=u*rp%s ;

    Mint ab ;
    Mint b1(1) ;
    Mint c1=(u*(N-r*rp)/s)%s ;
    int j ;
    Mint q,rr ;
    Mint sd ;
//    Mint w ;
    Mint t1,t2 ;
    if( sign(a1)==0 ) a1=s ;

Step2:    // Compute c
    for( j=1 ;;) {
        ab=a1*b1 ;
        if( j&1 )  {
            c=c1+s*((N+s2*(ab-c1))/s3) ;
            if( c<2*ab ) goto Step6;
        }
        else {
            c=c1&s ;   // ł낤 ?
        }
Step3:// Solve quadtatic rquation
        q=c*s+a1*r+b1*rp ;

//    d=square(c*s+a1*r+b1*rp) - 4*a1*b1*N ;
//cout << "res " ;
        d=square(q) - ((ab*N)<<2) ;
        if( sign(d)<0 ) goto Step5 ;
//if( d<0 ) Error(d<0) ;
//        sd=isqrt(d) ;
        sd=SquareTest(d) ;
//    if( d!=sd*sd ) goto Step5 ;
//cout << endl << "squarew 2" ;
//        if( d==sd*sd ) {
        if( sign(sd)>=0 ) {
            t1=q+sd ;
            t1>>=1 ;
            t2=q-sd ;
            t2>>=1 ;
        // Divisor found ?
//Step4:
//  if( a1==0 ) Error(why a1=0 ) ;
//  if( b1==0 ) Error(why b1=0 ) ;

            if( sign(ab)==0 ) goto Step5 ;
            divide(t1,a1,d,rr) ;
            if( sign(rr)==0 && (d-r)%s==0 ) {
                divide(t2,b1,q,rr) ;
                if( sign(rr)==0 && (q-rp)%s==0 ) {
                    return true ;
                }
            }
#if 0
            if( (t1%a1)==0 && mod((d=t1/a1)-r,s)==0 && (t2%b1)==0 && mod(t2/b1-rp,s)==0 ) {
                return true ;
            }
#endif
        }
Step5:
        if( ((j&1)==0) && sign(c)>0 ) {
//cout << endl << "j c " << j << " " << c ;
            c-=s ;              // c=c1 mod s
            goto Step3 ;
        }

Step6:
        if( a1==0 ) return false ;
        j++ ;
#if 1
        if( j&1 )
            q=(a0-1)/a1 ;
        else
            q=a0/a1 ;
#else
        q=(a0-(j&1))/a1 ;
#endif

        Swap(a0,a1) ;
        a1-=q*a0 ;      // a1=a0-q*a1
        Swap(b0,b1) ;
        b1-=q*b0 ;
        Swap(c0,c1) ;
        c1-=q*c0 ;
//    goto Step2 ;
    }

}
#if 1
// Algorithm 4.2.11 (Division in residue classes) We are given positice integers
// n,r, s with r<s<n and gcd(r,s)=1. This algorithm creates a list of all divisors of n
// that are congruent to r ( mod s).
bool div_res2(Mint& r,Mint& s,Mint& N,Mint& dd)
{
//  Initialize
    Mint ri=invmodp(r,s) ;
cout << endl << "ri " << ri ;

    Mint rp=(N*ri)%s ;
//  Mint a0=s,a1=rp*ri%s ;
    vector<Mint> a ;
    vector<Mint> b ;
    vector<Mint> c ;
    vector<Mint> q ;
    Mint d;
    Mint sd ;
    Mint u,v ;
    Mint threshold ;

    a.push_back(s) ;  a.push_back((rp*ri)%s) ;
    b.push_back(0) ;  b.push_back(1) ;
// Mint c1=(ri*(N-r*rp)/s)%s ;
    c.push_back(0) ;
//    c.push_back(((ri*N-r*a[1])/s)%s) ;  // ŌvZƂȂfobOׂ ?
    c.push_back((ri*(N-r*rp)/s)%s) ;
//    if( ((ri*N-r*a[1])%s)!=0 ) Error(not zero mod s) ;


    Mint wa,wq,wb,wc,wab ;
    int t ;
    int i,j ;

    for( t=2 ;; t++ ) {
        divide(a[t-2],a[t-1],wq,wa) ;
        if( t&1 ) {
            if( wa==0 ) { --wq ; wa=a[t-1] ; }
            a.push_back(wa) ;
            q.push_back(wq) ;
        }
        else {      // i is even
            a.push_back(wa) ;
            q.push_back(wq) ;
            if( wa==0 ) {
                break ;
            }
        }
    }

    for( i=2 ; i<t ; i++ ) {
        wb=b[i-2]-q[i]*b[i-1] ;
        b.push_back(wb) ;
        wc=c[i-2]-q[i]*c[i-1] ;
        c.push_back(wc) ;
    }
//  wa=a0-q*a1

Loop:
    for( i=1 ; i<t ; i++ ) {
        if( i&1 ) {
//          c=c1+s*((N+s2*(ab-c1))/s3) ;

            wab=2*a[i]*b[i] ;
            wq=wab/s ;
            wc=s*wq+c[i] ;

            while( wc<=wab ) wc+=s ;
            threshold=(wab>>1) + floor(Fint(N)/(s*s)) ;

        }
        else {
            wc=c[i]&s-s ;
            threshold=s ;

        }
j=0 ;
        for( ; wc<=threshold ; wc+=s ) {
            d=square(wc*s+a[i]*r+b[i]*rp)-4*a[i]*b[i]*N ;
j++ ;
if( j%1000== 0 )
cout << " " << j ;
            sd=SquareTest(d) ;
            if( d>=0 ) {
                u=(wc*s+a[i]*r+b[i]*rp)+sd ;
                u/=2 ;
                v=(wc*s+a[i]*r+b[i]*rp)-sd ;
                v/=2 ;
                if( u*a[i]==0 ) continue ;
                if( v*b[i]==0 ) continue ;
cout << endl << "find a solution" ;
cout << endl << "i " << i ;
                cout << endl << " a b " << a[i] << " " << b[i] ;
                cout << endl << "u " << u ;
                cout << endl << "v " << v << flush ;
                if( a[i]!=0 ) {
                   cout << endl << "u/a[i] " << u/a[i] ;
                    cout << endl << (u/a[i]-r)/s ;
                }
                if( b[i]!=0 ) {
                   cout << endl << "v/b[i] " << v/b[i] ;
  //                 if( (N%(v/b[i]))!=0 ) Error(shs) ;
                    cout << endl << (v/b[i]-rp)/s ;
                }
//          cout << endl << (v/b[i]-rp)/s ;
                return true ;
            }
        }
    }
    return false ;


}

#endif
#ifdef DIVRES_TEST
int main(void)
{
    Mint r,s,N ;
    Mint w ;
    Mint ww ;
    s=power(Mint(10),35UL) ;
    r=137 ;
    w=1 ;
    w<<=61 ;
    --w ;
    ww=1 ;
    ww<<=31 ;
    ww-- ;
    N=(w*s+r)*
     ( ww*s+r)
    *1234567  ;
    cout << endl << "s " << s ;
    cout << endl << "N " << N ;
    cout << endl << (w*s+r) ;
    cout << endl << (ww*s+r) ;
//  r=97 ;
    cout << endl << " " << div_res(r,s,N,w) ;
    cout << endl << "w " << w ;
//    cout << endl << " " << div_res2(r,s,N,w) ;
}
#endif
