//
//  Copyright (C) by S.Tomabechi 1998
//  All rights reserved.
//
//  random number in [0,1)
//
//  c.f. "Numerical Recipes in C" 2-nd edition p284 (ranqd1)
//
//  (ǂ)𔭐
//  [0,1) ̒lԂ
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define jflmsk 0x007fffff
#define jflone  0x3f800000

// Xn : seed of randiom number.
// return value  : float real number in [0,1)
float frandom(unsigned long& Xn)
{
  float r ;
  __asm {

    mov   esi,Xn

    mov   ecx,1664525
    mov   eax,[esi]
    mul   ecx
    add   eax,1013904223
    mov   [esi],eax

    and   eax,jflmsk
    or    eax,jflone
    mov   r,eax
  }

  return r-1.0f ;
}


// Xn : seed of randiom number.
// return value  : double real number in [0,1)
double drandom(unsigned long& Xn)
{
  double r ;
  __asm {

    mov   esi,Xn

    mov   ecx,1664525             // Xn*1664525+1013904223
    mov   eax,[esi]
    mul   ecx
    add   eax,1013904223
    mov   ebx,eax
    mul   ecx                     // Xn*1664525+1013904223
    add   eax,1013904223
    mov   [esi],eax     // ̎Z[u

    mov   dword ptr r,edx
    and   eax,0x000fffff          // 2.xxxx
    or    eax,0x3ff00000          // w 0 ̐̒lɂ
    mov   dword ptr r[4],eax
  }

  return r-1.0 ;
}



/******************
#include <stdlib.h>
#include <iostream.h>

int main(void)
{
  static unsigned long X(13282) ;
  int j ;
  for( j=0 ; j<1000 ; j++ ) {
    cout << frandom(X) << " " << flush ;
    cout << drandom(X) << " " << endl ;
  }
  return 0 ;
}
*****************/
