//
//  Copyright (C) by S.Tomabechi 2000
//  All rights reserved.
//
//  N       (I) : modulus
//  nAray   (I) :  size of array q
//  q       (I/O) : array of integers
//  g       (O)   :  񐔂̐
//  nPrimes (I) : f̌
//  Primes  (I) : f
//
//  Assumption g!=0  q[i]!=0
#ifdef __BORLANDC__
#pragma inline
#endif

#include "Mint.hpp"
#define MINT_SIZE 16           // sizeof(class Mint)

#if 1
void GCD(long nAray,Mint* q,Mint& g,unsigned long nPrimes,unsigned long* Primes)
{

    long j,k ;
    unsigned long p(0) ;
//unsigned long maxp(0) ;
    k=ndigit(q[0])+ndigit(g) ;
    if( k>g.ndim() ) {
      g.reallocate(k) ;
    }
//    g=1 ;
    for( k=0 ; k<nPrimes ; k++ ) {
        __asm {
            mov ebx,k
            mov esi,Primes
            lea esi,[esi+4*ebx]
            mov eax,[esi]
            cmp eax,p
            je  NEXT_PRM
            mov p,eax
            or  eax,eax
            jz  NEXT_PRM
        }
    #if 0
        if( p==Primes[k] ) continue ;
        p=Primes[k] ;
        if( p==0 ) continue ;
    #endif
        for(;;) {

            __asm {
                xor edx,edx
                mov ebx,nAray
                mov edi,q
            }
NEXT_NUM1:
            __asm {
                dec ebx
                js  DIV_EXACT

                mov ecx,[edi.nDigit]
                dec ecx
                mov esi,[edi]
            }
DIV_LOOP1:
            __asm {
                mov eax,[esi+4*ecx]
                div p
                dec ecx
                jns DIV_LOOP1

                or  edx,edx
                jnz NEXT_PRM
                lea edi,[edi+MINT_SIZE]
                jmp NEXT_NUM1
            }



//            for( j=0 ; j<nAray ; j++ ) q[j]/=p ;

DIV_EXACT:
            __asm {
                mov ebx,nAray
                mov edi,q
            }
NEXT_NUM:
            __asm {
                dec ebx
                js  PRODUCT

                mov ecx,[edi.nDigit]
                dec ecx
                mov esi,[edi]
            }
DIV_LOOP2:
                __asm {
                    mov eax,[esi+4*ecx]
                    div p
                    mov [esi+4*ecx],eax
                    dec ecx
                    jns DIV_LOOP2

                    mov ecx,[edi.nDigit]
                    dec ecx
                    cmp dword ptr [esi+4*ecx],0
                    jnz NEXT
                    dec dword ptr [edi.nDigit]
                }
NEXT:
                __asm {
                    lea edi,[edi+MINT_SIZE]
                    jmp NEXT_NUM
                }
PRODUCT:
        __asm {
            mov edi,g
            mov ecx,[edi.nDigit]
            mov esi,[edi]

            xor ebx,ebx
        }
MULP:
        __asm {
            mov eax,[esi]
            mul p
            add eax,ebx
            mov [esi],eax
            adc edx,0
            mov ebx,edx
            lea esi,[esi+4]
            dec ecx
            jnz MULP
        }
END_MUL:
        __asm {
            or  edx,edx
            jz  TRY_MORE
            mov [esi],edx
            inc dword ptr [edi.nDigit]
        }

TRY_MORE:
//maxp=p ;
//            g*=p ;
        }

NEXT_PRM:
    }
//cout << " maxp " << maxp << " " ;
}



//
//  compute greatest common divisors
//
//  nAray   (I) :  size of array q
//  q       (I/O) : array of integers
//  nPrimes (I) : # of priems
//  Primes  (I) : primes
//  index   (O) exponent of number with respect to primes
//


void GCD(long nAray,Mint* q,unsigned long nPrimes,unsigned long* Primes,unsigned long* index)
{

    long j,k ;
    unsigned long p(0) ;
    for( k=0 ; k<nPrimes ; k++ ) {
        __asm {
            mov ebx,k
            mov esi,Primes
            lea esi,[esi+4*ebx]
            mov eax,[esi]
            cmp eax,p
            je  NEXT_PRM
            mov p,eax
            or  eax,eax
            jz  NEXT_PRM
        }
    #if 0
        if( p==Primes[k] ) continue ;
        p=Primes[k] ;
        if( p==0 ) continue ;
    #endif
        for(;;) {

            __asm {
                xor edx,edx
                mov ebx,nAray
                mov edi,q
            }
NEXT_NUM1:
            __asm {
                dec ebx
                js  DIV_EXACT

                mov ecx,[edi.nDigit]
                dec ecx
                mov esi,[edi]
            }
DIV_LOOP1:
            __asm {
                mov eax,[esi+4*ecx]
                div p
                dec ecx
                jns DIV_LOOP1

                or  edx,edx
                jnz NEXT_PRM
                lea edi,[edi+MINT_SIZE]
                jmp NEXT_NUM1
            }



//            for( j=0 ; j<nAray ; j++ ) q[j]/=p ;

DIV_EXACT:
            __asm {
                mov ebx,nAray
                mov edi,q
            }
NEXT_NUM:
            __asm {
                dec ebx
                js  PRODUCT

                mov ecx,[edi.nDigit]
                dec ecx
                mov esi,[edi]
            }
DIV_LOOP2:
                __asm {
                    mov eax,[esi+4*ecx]
                    div p
                    mov [esi+4*ecx],eax
                    dec ecx
                    jns DIV_LOOP2

                    mov ecx,[edi.nDigit]
                    dec ecx
                    cmp dword ptr [esi+4*ecx],0
                    jnz NEXT
                    dec dword ptr [edi.nDigit]
                }
NEXT:
                __asm {
                    lea edi,[edi+MINT_SIZE]
                    jmp NEXT_NUM
                }
PRODUCT:
        __asm {
            mov edi,index
            mov ebx,k
            lea edi,[edi+4*ebx]
            inc dword ptr [edi]
        }
MULP:
        __asm {
        }
END_MUL:
        __asm {
        }

TRY_MORE:
//maxp=p ;
//            g*=p ;
        }

NEXT_PRM:
    }
//cout << " maxp " << maxp << " " ;
}

#else
void GCD(long nAray,Mint* q,Mint& g,unsigned long nPrimes,unsigned long* Primes)
{
    long j,k ;
    unsigned long p(0) ;
//    g=1 ;
    for( k=0 ; k<nPrimes ; k++ ) {
        if( p==Primes[k] ) continue ;
        p=Primes[k] ;
        if( p==0 ) continue ;
        for(;;) {
            for( j=0 ; j<nAray ; j++ ) {
                if( q[j]%p!=0 ) goto NEXT_PRM ;
            }
            for( j=0 ; j<nAray ; j++ ) q[j]/=p ;
            g*=p ;
        }

NEXT_PRM:
    }
}
#endif

