//
//  Copyright (C) by S.Tomabechi 1993-1997
//  All rights reserved.
//
//  complex functions 
//
#ifndef __FUNC_COMPLEX_HPP
#define __FUNC_COMPLEX_HPP
#include "Complex.hpp"
#include <iostream.h>

Complex tan(const Complex& x) ;
Complex atan(const Complex& x) ;

Complex cosh(const Complex& x) ;
Complex sinh(const Complex& x) ;

Fint& real(Complex& c) ;         // real part 
Fint& imag(Complex& c) ;         // imaginary part 

Complex conj(const Complex& c) ; // conjugate
Fint  abs(const Complex& c) ;    // absolute value 
Fint  norm(const Complex& c) ;   //  z*z' square of absolute value 
Complex exp(const Complex& x) ;  // exponential function
Complex log(const Complex& x) ;  // logarithm  branch with less argument 
Complex sqrt(const Complex& x) ; // square root branch with less argument 
Complex cos(const Complex& x) ;  // cosine 
Complex sin(const Complex& x) ;  // sine 
Complex tan(const Complex& x) ;  // tangent 
Complex atan(const Complex& x) ; // arc tangent 
Complex cosh(const Complex& x) ; // hyperbolic cosine 
Complex sinh(const Complex& x) ; // hyperbolic sine 
Complex eta(Complex tau) ;       // Dedekind eta function 
Complex power(const Complex& x,const Complex& y) ;  // power x^y
Complex power(const Complex& x,const Mint& n) ;
Complex power(const Complex& x,const Fint& y) ;
Complex power(const Fint& x,const Complex& y) ;
Complex power(const Mint& n,const Complex& c) ;
void Swap(Complex& a,Complex& b) ;

ostream& operator<<(ostream& os,const Complex& c) ;
istream& operator>>(istream& is,Complex& c) ;
void write(ostream& os,const Complex& c) ;
void read(istream& is,Complex& c) ;

#endif